searchNodes=[{"doc":"Riverside - Plain WebSocket Server Framework for Elixir Getting Started Handler At first, you need to prepare your own Handler module with use Riverside line. in handle_message/3 , process messages sent by client. This doesn't depend on some protocol like Socket.io. So do client-side, you don't need to prepared some libraries. defmodule MySocketHandler do # set &#39;otp_app&#39; param like Ecto.Repo use Riverside , otp_app : :my_app @impl Riverside def handle_message ( msg , session , state ) do # `msg` is a &#39;TEXT&#39; or &#39;BINARY&#39; frame sent by client, # process it as you like deliver_me ( msg ) { :ok , session , state } end end Application child_spec And in your Application module, set child spec for your supervisor. defmodule MyApp do use Application def start ( _type , _args ) do [ # ... { Riverside , [ handler : MySocketHandler ] } ] |&gt; Supervisor . start_link ( [ strategy : :one_for_one , name : MyApp.Spervisor ] ) end end Configuration config :my_app , MySocketHandler , port : 3000 , path : &quot;/my_ws&quot; , max_connections : 10000 , # don&#39;t accept connections if server already has this number of connections max_connection_age : :infinity , # force to disconnect a connection if the duration passed. if :infinity is set, do nothing. idle_timeout : 120_000 , # disconnect if no event comes on a connection during this duration reuse_port : false , # TCP SO_REUSEPORT flag show_debug_logs : false , transmission_limit : [ capacity : 50 , # if 50 frames are sent on a connection duration : 2000 # in 2 seconds, disconnect it. ] I’ll show you detailed description below. But you will know most of them when you see them. Run Launch your application, then the WebSocket service is provided with an endpoint like the following. ws :// localhost : 3000 / my_ws And at the same time, we can also access to http :// localhost : 3000 / health If you send a HTTP GET request to this URL, it returns response with status code 200, and text content &quot;OK&quot;. This is just for health check. This feature is defined in a Plug Router named Riverside.Router , and this is configured as default router param for child spec. So, you can defined your own Plug Router if you set as below. In your Application module defmodule MyApp do use Application def start ( _type , _args ) do [ # ... { Riverside , [ handler : MySocketHandler , router : MyRouter , # Set your Plug Router here ] } ] |&gt; Supervisor . start_link ( [ strategy : :one_for_one , name : MyApp.Spervisor ] ) end end Handler's Callbacks You can also define callback functions other than handle_message/3 . For instance, there are functions named init , terminate , and handle_info . If you are accustomed to GenServer, you can easily imagine what they are, though their interface is little bit different. defmodule MySocketHandler do use Riverside , otp_app : :my_app @impl Riverside def init ( session , state ) do # initialization { :ok , session , state } end @impl Riverside def handle_message ( msg , session , state ) do deliver_me ( msg ) { :ok , session , state } end @impl Riverside def handle_info ( into , session , state ) do # handle message sent to this process { :ok , session , state } end @impl Riverside def terminate ( reason , session , state ) do 　 　 # cleanup :ok end end Authentication and Session Here, I'll describe authenticate/1 callback function. defmodule MySocketHandler do use Riverside , otp_app : :my_app @impl Riverside def authenticate ( req ) do { username , password } = req . basic case MyAuthenticator . authenticate ( username , password ) do { :ok , user_id } -&gt; state = %{ } { :ok , user_id , state } { :error , :invalid_password } -&gt; error = auth_error_with_code ( 401 ) { :error , error } end end @impl Riverside def init ( session , state ) do { :ok , session , state } end @impl Riverside def handle_message ( msg , session , state ) do deliver_me ( msg ) { :ok , session , state } end @impl Riverside def handle_info ( into , session , state ) do { :ok , session , state } end @impl Riverside def terminate ( reason , session , state ) do :ok end end The argument of authenticate/1 is a struct of Riverside.AuthRequest.t . And it has Map members queries: Map includes HTTP request's query params headers: Map includes HTTP headers # When client access with a URL such like ws://localhost:3000/my_ws?token=FOOBAR, # And you want to authenticate the `token` parameter (&quot;FOOBAR&quot;, this time) @impl Riverside def authenticate ( req ) do # You can pick the parameter like as below token = req . queries [ &quot;token&quot; ] # ... end # Or else you want to authenticate with `Authorization` HTTP header. @impl Riverside def authenticate ( req ) do # You can pick the header value like as below auth_header = req . headers [ &quot;authorization&quot; ] # ... end The fact is that, you don't need to parse Authorization header by yourself, if you want to do Basic or Bearer authentication. # Pick up `username` and `password` from `Basic` Authorization header. # If it doesn&#39;t exist, `username` and `password` become empty strings. @impl Riverside def authenticate ( req ) do { username , password } = req . basic # ... end # Pick up token value from `Bearer` Authorization header # If it doesn&#39;t exist, `token` become empty string. @impl Riverside def authenticate ( req ) do token = req . bearer_token # ... end Authentication failure If authentication failure, you need to return {:error, Riverside.AuthError.t} . You can build Riverside.AuthError struct with auth_error_with_code/1 . Pass proper HTTP status code. @impl Riverside def authenticate ( req ) do token = req . bearer_token case MyAuth . authenticate ( token ) do { :error , :invalid_token } -&gt; error = auth_error_with_code ( 401 ) { :error , error } # _ -&gt; ... end end You can use put_auth_error_header/2 to put response header error = auth_erro_with_code ( 400 ) |&gt; puth_auth_error_header ( &quot;WWW-Authenticate&quot; , &quot;Basic realm= \\&quot; example.org \\&quot; &quot; ) And two more shortcuts, put_auth_error_basic_header and put_auth_error_bearer_header . error = auth_erro_with_code ( 401 ) |&gt; puth_auth_error_basic_header ( &quot;example.org&quot; ) # This puts `WWW-Authenticate: Basic realm=&quot;example.org&quot;` error = auth_erro_with_code ( 401 ) |&gt; puth_auth_error_bearer_header ( &quot;example.org&quot; ) # This puts `WWW-Authenticate: Bearer realm=&quot;example.org&quot;` error = auth_erro_with_code ( 400 ) |&gt; puth_auth_error_bearer_header ( &quot;example.org&quot; , &quot;invalid_token&quot; ) # This puts `WWW-Authenticate: Bearer realm=&quot;example.org&quot;, error=&quot;invalid_token&quot;` Successful authentication @impl Riverside def authenticate ( req ) do token = req . bearer_token case MyAuth . authenticate ( token ) do { :ok , user_id } -&gt; session_id = create_random_string ( ) state = %{ } { :ok , user_id , session_id , state } # _ -&gt; ... end end If authentication results in success, return {:ok, user_id, session_id, state} . You can put any data into state , same as you do in init in GenServer. session_id should be random string. You also can return {:ok, user_id, state} , and Then session_id will be generated automatically. And init/3 will be called after successful auth response. session Now I can describe about the session parameter included for each callback functions. This is a Riverside.Session.t struct, and it includes some parameters like user_id and session_id . When you omit to define authenticate/1 , both user_id and session_id will be set random value. @impl Riverside def handle_message ( msg , session , state ) do # session.user_id # session.session_id end Message and Delivery Message Format If a client sends a simple TEXT frame with JSON format like the following { &quot;to&quot;: 1111, &quot;body&quot;: &quot;Hello&quot; } You can handle this JSON message as a Map . @impl Riverside def handle_message ( incoming_message , session , state ) do dest_user_id = incoming_message [ &quot;to&quot; ] body = incoming_message [ &quot;body&quot; ] outgoing_message = %{ &quot;from&quot; =&gt; &quot; \#{ session . user_id } &quot; , &quot;body&quot; =&gt; body , } deliver_user ( dest_user_id , outgoing_message ) { :ok , session , state } end Then the user who is set as destination(user_id == 1111, in this example) receives TEXT frame { &quot;from&quot;: 2222, &quot;body&quot;: &quot;Hello&quot; } This is because Riverside.Codec.JSON is set for codec config as default. config :my_app , MySocketHandler , codec : Riverside.Codec.JSON This codec decodes incoming message, and encodes outgoing message. If you want to accept TEXT frames but don't want encode/decode them. Should set Riverside.Codec.RawText config :my_app , MySocketHandler , codec : Riverside.Codec.RawText If you want to accept BINARY frames but don't want encode/decode them. Should set Riverside.Codec.RawBinary config :my_app , MySocketHandler , codec : Riverside.Codec.RawBinary Custom Codec The fact is that, JSON codec module is written with small amount of code. Take a look at the inside. defmodule Riverside.Codec.JSON do @behaviour Riverside.Codec @impl Riverside.Codec def frame_type do :text end @impl Riverside.Codec def encode ( msg ) do case Poison . encode ( msg ) do { :ok , value } -&gt; { :ok , value } { :error , _exception } -&gt; { :error , :invalid_message } end end @impl Riverside.Codec def decode ( data ) do case Poison . decode ( data ) do { :ok , value } -&gt; { :ok , value } { :error , _exception } -&gt; { :error , :invalid_message } end end end No explanation needed to write your own codec. It's too simple. Delivery There is a module named Riverside.LocalDelivery . With its deliver/2 function, you can deliver messages to sessions connected to the server. def handle_message ( msg , session , state ) do dest_user_id = msg [ &quot;to&quot; ] body = msg [ &quot;body&quot; ] outgoing = %{ from : session . user_id , body : body , } 　 Riverside.LocalDelivery . deliver ( { :user , dest_user_id } , { :text , Poison . encode! ( outgoing ) } ) { :ok , session , state } end First argument is a tuple which represents a destination , and second is a tuple which represents a frame . frame should be {:text, body} or {:binary, body} . choose proper one. OK, let's describe about 3 kinds of destination. USER DESTINATION { :user , user_id } Send message to all the connections for this user. Recent trend is multi device support. One single user may have a multi connections at the same time. SESSION DESTINATION { :session , user_id , session_id } Send message to a specific connection for this user. Sometime, this may be a very important feature. For instance, WebRTC-signaling , end-to-end encryption . CHANNEL DESTINATION { :channel , channel_id } Send message to all the members who is belonging to this channel. How to join or leave channels? See the example below. def init ( session , state ) do Riverside.LocalDelivery . join_channel ( &quot;my_channel&quot; ) { :ok , session , state } end def handle_message ( msg , session , state ) do dest_channel_id = msg [ &quot;to&quot; ] body = msg [ &quot;body&quot; ] outgoing = %{ from : session . user_id , body : body , } 　 Riverside.LocalDelivery . deliver ( { :channel , dest_channel_id } , { :text , Poison . encode! ( outgoing ) } ) { :ok , session , state } end def terminate ( session , state ) do Riverside.LocalDelivery . leave_channel ( &quot;my_channel&quot; ) :ok end Shortcuts for delivery If you want to deliver messages from within your handler, You don't need to use Riverside.LocalDelivery directly. Here are handy functions. Let's replace LocalDelivery module to handy version. def init ( session , state ) do join_channel ( &quot;my_channel&quot; ) { :ok , session , state } end def handle_message ( msg , session , state ) do dest_channel_id = msg [ &quot;to&quot; ] body = msg [ &quot;body&quot; ] outgoing = %{ from : session . user_id , body : body , } # same as LocalDelivery.deliver # deliver({:channel, dest_channel_id}, {:text, Poison.encode!(outgoing)}) # handy version, `codec` works on this way, so you don&#39;t need to encode by yourself. 　 deliver_channel ( dest_channel_id , outgoing ) # If you want to send message to `user` # deliver_user(dest_user_id, outgoing) # If you want to send message to `session` # deliver_session(dest_user_id, dest_user_session_id, outgoing) { :ok , session , state } end def terminate ( session , state ) do leave_channel ( &quot;my_channel&quot; ) :ok end Echo Back To deliver message to sender's connection, you can write like following. deliver_me ( msg ) This is same as deliver_session ( session . user_id , session . session_id , msg ) Close Following like can deliver close message to specific connection. Riverside.LocalDelivery . close ( user_id , session_id ) or just close function. close ( ) Example def handle_message ( msg , session , state ) do if is_bad_message ( msg ) do close ( ) else # ... end { :ok , session , state } end Scalable Service LocalDelivery module and its handy shortcuts are just for local . This works only for communications in a single server. If you need to support more scalable service, consider other solutions. For example, Redis-PubSub, RabbitMQ, or gnatsd. Here is a example with https://github.com/lyokato/roulette (HashRing-ed gnatsd cluster client) def init ( session , state ) do with { :ok , _ } &lt;- Roulette . sub ( &quot;user: \#{ session . user_id } &quot; ) , { :ok , _ } &lt;- Roulette . sub ( &quot;session: \#{ session . user_id } / \#{ session . session_id } &quot; ) do { :ok , session , state } else error -&gt; Logger . wran &quot;failed to setup subscription: \#{ inspect error } &quot; { :error , :system_error } end end def handle_message ( msg , session , state ) do to = msg [ &quot;to&quot; ] body = msg [ &quot;body&quot; ] outgoing = %{ from : session . user_id , body : body , } case Roulette . pub ( &quot;user: \#{ to } &quot; , Poison . encode! ( outgoing ) ) do :ok -&gt; { :ok , session , state } :error -&gt; { :error , :system_error } end end def handle_info ( :pubsub_message , topic , msg , pid } , session , state ) do deliver_me ( :text , msg ) { :ok , session , state } end def terminate ( session , state ) do :ok end Configurations child_spec { Riverside , [ handler : MySocketHandler , router : MyRouter , ] } keyword default value description handler -- Required. Set your own handler module. router Riverside.Router Plug.Router implementation module which provides endpoints other than ws(s):// config file config :my_app , MySocketHandler , port : 3000 , path : &quot;/my_ws&quot; , codec : Riverside.Codec.RawBinary , max_connections : 10000 , max_connection_age : :infinity , show_debug_logs : false , idle_timeout : 120_000 , reuse_port : false , transmission_limit : [ duration : 2000 , capacity : 50 ] key default value description port 3000 Port number this http server listens. path / Path for WebSocket endpoint. max_connections 65536 maximum number of connections this server can keep. you also pay attention to a configuration for a number of OS's file descriptors max_connection_age :infinity Force to disconnect a connection if the duration(milliseconds) passed. Then terminate/3 will be called with :over_age as a reason. if :infinity is set, do nothing. codec Riverside.Codec.JSON text/binary frame codec. show_debug_logs false If this flag is true. detailed debug logs will be shown. transmission_limit duration:2000, capacity:50 if &lt;:capacity&gt; frames are sent on a connection in &lt;:duration&gt; milliseconds, disconnect it.Then terminate/3 will be called with :too_many_messages as a reason. idle_timeout 60000 Disconnect if no event comes on a connection during this duration reuse_port false TCP SO_REUSEPORT flag Dynamic Port Number You may set port number dinamically. You can set port number like following. config :my_app , MySocketHandler , port : { :system , &quot;MY_PORT&quot; , 3000 } Then, port number is picked from runtime environment variable &quot;MY_PORT&quot;. if it doesn't exist, 3000 will be used.","ref":"Riverside.html","title":"Riverside","type":"behaviour"},{"doc":"","ref":"Riverside.html#c:__config__/0","title":"Riverside.__config__/0","type":"callback"},{"doc":"","ref":"Riverside.html#c:__handle_authentication__/1","title":"Riverside.__handle_authentication__/1","type":"callback"},{"doc":"","ref":"Riverside.html#c:__handle_data__/4","title":"Riverside.__handle_data__/4","type":"callback"},{"doc":"","ref":"Riverside.html#c:authenticate/1","title":"Riverside.authenticate/1","type":"callback"},{"doc":"","ref":"Riverside.html#child_spec/1","title":"Riverside.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.html#c:handle_info/3","title":"Riverside.handle_info/3","type":"callback"},{"doc":"","ref":"Riverside.html#c:handle_message/3","title":"Riverside.handle_message/3","type":"callback"},{"doc":"","ref":"Riverside.html#c:init/2","title":"Riverside.init/2","type":"callback"},{"doc":"","ref":"Riverside.html#c:terminate/3","title":"Riverside.terminate/3","type":"callback"},{"doc":"","ref":"Riverside.html#t:terminate_reason/0","title":"Riverside.terminate_reason/0","type":"type"},{"doc":"","ref":"Riverside.AuthError.html","title":"Riverside.AuthError","type":"module"},{"doc":"","ref":"Riverside.AuthError.html#auth_error_with_code/1","title":"Riverside.AuthError.auth_error_with_code/1","type":"function"},{"doc":"","ref":"Riverside.AuthError.html#put_auth_error_basic_header/2","title":"Riverside.AuthError.put_auth_error_basic_header/2","type":"function"},{"doc":"","ref":"Riverside.AuthError.html#put_auth_error_bearer_header/3","title":"Riverside.AuthError.put_auth_error_bearer_header/3","type":"function"},{"doc":"","ref":"Riverside.AuthError.html#put_auth_error_header/3","title":"Riverside.AuthError.put_auth_error_header/3","type":"function"},{"doc":"","ref":"Riverside.AuthError.html#t:t/0","title":"Riverside.AuthError.t/0","type":"type"},{"doc":"","ref":"Riverside.AuthRequest.html","title":"Riverside.AuthRequest","type":"module"},{"doc":"","ref":"Riverside.AuthRequest.html#new/2","title":"Riverside.AuthRequest.new/2","type":"function"},{"doc":"","ref":"Riverside.AuthRequest.html#t:basic_credential/0","title":"Riverside.AuthRequest.basic_credential/0","type":"type"},{"doc":"","ref":"Riverside.AuthRequest.html#t:t/0","title":"Riverside.AuthRequest.t/0","type":"type"},{"doc":"","ref":"Riverside.Codec.html","title":"Riverside.Codec","type":"behaviour"},{"doc":"","ref":"Riverside.Codec.html#c:decode/1","title":"Riverside.Codec.decode/1","type":"callback"},{"doc":"","ref":"Riverside.Codec.html#c:encode/1","title":"Riverside.Codec.encode/1","type":"callback"},{"doc":"","ref":"Riverside.Codec.html#c:frame_type/0","title":"Riverside.Codec.frame_type/0","type":"callback"},{"doc":"","ref":"Riverside.Codec.html#t:frame_type/0","title":"Riverside.Codec.frame_type/0","type":"type"},{"doc":"","ref":"Riverside.Codec.JSON.html","title":"Riverside.Codec.JSON","type":"module"},{"doc":"","ref":"Riverside.Codec.MessagePack.html","title":"Riverside.Codec.MessagePack","type":"module"},{"doc":"","ref":"Riverside.Codec.RawBinary.html","title":"Riverside.Codec.RawBinary","type":"module"},{"doc":"","ref":"Riverside.Codec.RawText.html","title":"Riverside.Codec.RawText","type":"module"},{"doc":"Helper for config data","ref":"Riverside.Config.html","title":"Riverside.Config","type":"module"},{"doc":"Ensure passed module is compiled already. Or else, this function raise an error.","ref":"Riverside.Config.html#ensure_module_loaded/1","title":"Riverside.Config.ensure_module_loaded/1","type":"function"},{"doc":"Get runtime cowboy options","ref":"Riverside.Config.html#get_cowboy_opts/1","title":"Riverside.Config.get_cowboy_opts/1","type":"function"},{"doc":"Get runtime port number from configuration","ref":"Riverside.Config.html#get_port/1","title":"Riverside.Config.get_port/1","type":"function"},{"doc":"Get runtime TLS flag","ref":"Riverside.Config.html#get_tls/1","title":"Riverside.Config.get_tls/1","type":"function"},{"doc":"Get runtime TLS cert file","ref":"Riverside.Config.html#get_tls_certfile/1","title":"Riverside.Config.get_tls_certfile/1","type":"function"},{"doc":"Get runtime TLS key file","ref":"Riverside.Config.html#get_tls_keyfile/1","title":"Riverside.Config.get_tls_keyfile/1","type":"function"},{"doc":"Load handler's configuration.","ref":"Riverside.Config.html#load/2","title":"Riverside.Config.load/2","type":"function"},{"doc":"Pick the TransmissionLimitter's parameters from Handlers configuration.","ref":"Riverside.Config.html#transmission_limit/1","title":"Riverside.Config.transmission_limit/1","type":"function"},{"doc":"","ref":"Riverside.Config.html#t:port_type/0","title":"Riverside.Config.port_type/0","type":"type"},{"doc":"","ref":"Riverside.Config.html#t:t/0","title":"Riverside.Config.t/0","type":"type"},{"doc":"","ref":"Riverside.Connection.html","title":"Riverside.Connection","type":"module"},{"doc":"Callback implementation for :cowboy_websocket.init/2 .","ref":"Riverside.Connection.html#init/2","title":"Riverside.Connection.init/2","type":"function"},{"doc":"","ref":"Riverside.Connection.html#new/5","title":"Riverside.Connection.new/5","type":"function"},{"doc":"Callback implementation for :cowboy_websocket.terminate/3 .","ref":"Riverside.Connection.html#terminate/3","title":"Riverside.Connection.terminate/3","type":"function"},{"doc":"Callback implementation for :cowboy_websocket.websocket_handle/2 .","ref":"Riverside.Connection.html#websocket_handle/2","title":"Riverside.Connection.websocket_handle/2","type":"function"},{"doc":"Callback implementation for :cowboy_websocket.websocket_info/2 .","ref":"Riverside.Connection.html#websocket_info/2","title":"Riverside.Connection.websocket_info/2","type":"function"},{"doc":"Callback implementation for :cowboy_websocket.websocket_init/1 .","ref":"Riverside.Connection.html#websocket_init/1","title":"Riverside.Connection.websocket_init/1","type":"function"},{"doc":"","ref":"Riverside.Connection.html#t:shutdown_reason/0","title":"Riverside.Connection.shutdown_reason/0","type":"type"},{"doc":"","ref":"Riverside.Connection.html#t:t/0","title":"Riverside.Connection.t/0","type":"type"},{"doc":"","ref":"Riverside.EndpointSupervisor.html","title":"Riverside.EndpointSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.EndpointSupervisor.html#child_spec/1","title":"Riverside.EndpointSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.EndpointSupervisor.html#children/1","title":"Riverside.EndpointSupervisor.children/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Riverside.EndpointSupervisor.html#init/1","title":"Riverside.EndpointSupervisor.init/1","type":"function"},{"doc":"","ref":"Riverside.EndpointSupervisor.html#start_link/1","title":"Riverside.EndpointSupervisor.start_link/1","type":"function"},{"doc":"","ref":"Riverside.ExceptionGuard.html","title":"Riverside.ExceptionGuard","type":"module"},{"doc":"","ref":"Riverside.ExceptionGuard.html#guard/3","title":"Riverside.ExceptionGuard.guard/3","type":"function"},{"doc":"","ref":"Riverside.IO.Random.html","title":"Riverside.IO.Random","type":"module"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.bigint/0 .","ref":"Riverside.IO.Random.html#bigint/0","title":"Riverside.IO.Random.bigint/0","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.hex/1 .","ref":"Riverside.IO.Random.html#hex/1","title":"Riverside.IO.Random.hex/1","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.uuid/0 .","ref":"Riverside.IO.Random.html#uuid/0","title":"Riverside.IO.Random.uuid/0","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Behaviour.html","title":"Riverside.IO.Random.Behaviour","type":"behaviour"},{"doc":"","ref":"Riverside.IO.Random.Behaviour.html#c:bigint/0","title":"Riverside.IO.Random.Behaviour.bigint/0","type":"callback"},{"doc":"","ref":"Riverside.IO.Random.Behaviour.html#c:hex/1","title":"Riverside.IO.Random.Behaviour.hex/1","type":"callback"},{"doc":"","ref":"Riverside.IO.Random.Behaviour.html#c:uuid/0","title":"Riverside.IO.Random.Behaviour.uuid/0","type":"callback"},{"doc":"","ref":"Riverside.IO.Random.Real.html","title":"Riverside.IO.Random.Real","type":"module"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.bigint/0 .","ref":"Riverside.IO.Random.Real.html#bigint/0","title":"Riverside.IO.Random.Real.bigint/0","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.hex/1 .","ref":"Riverside.IO.Random.Real.html#hex/1","title":"Riverside.IO.Random.Real.hex/1","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.uuid/0 .","ref":"Riverside.IO.Random.Real.html#uuid/0","title":"Riverside.IO.Random.Real.uuid/0","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html","title":"Riverside.IO.Random.Sandbox","type":"module"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.bigint/0 .","ref":"Riverside.IO.Random.Sandbox.html#bigint/0","title":"Riverside.IO.Random.Sandbox.bigint/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.IO.Random.Sandbox.html#child_spec/1","title":"Riverside.IO.Random.Sandbox.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#create_and_set_bigint/0","title":"Riverside.IO.Random.Sandbox.create_and_set_bigint/0","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#create_and_set_hex/1","title":"Riverside.IO.Random.Sandbox.create_and_set_hex/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#create_and_set_uuid/0","title":"Riverside.IO.Random.Sandbox.create_and_set_uuid/0","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.hex/1 .","ref":"Riverside.IO.Random.Sandbox.html#hex/1","title":"Riverside.IO.Random.Sandbox.hex/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Riverside.IO.Random.Sandbox.html#init/1","title":"Riverside.IO.Random.Sandbox.init/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#mode/1","title":"Riverside.IO.Random.Sandbox.mode/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#set_bigint/1","title":"Riverside.IO.Random.Sandbox.set_bigint/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#set_hex/1","title":"Riverside.IO.Random.Sandbox.set_hex/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#set_uuid/1","title":"Riverside.IO.Random.Sandbox.set_uuid/1","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#start_link/0","title":"Riverside.IO.Random.Sandbox.start_link/0","type":"function"},{"doc":"Callback implementation for Riverside.IO.Random.Behaviour.uuid/0 .","ref":"Riverside.IO.Random.Sandbox.html#uuid/0","title":"Riverside.IO.Random.Sandbox.uuid/0","type":"function"},{"doc":"","ref":"Riverside.IO.Random.Sandbox.html#t:mode/0","title":"Riverside.IO.Random.Sandbox.mode/0","type":"type"},{"doc":"","ref":"Riverside.IO.Timestamp.html","title":"Riverside.IO.Timestamp","type":"module"},{"doc":"","ref":"Riverside.IO.Timestamp.Behaviour.html","title":"Riverside.IO.Timestamp.Behaviour","type":"behaviour"},{"doc":"","ref":"Riverside.IO.Timestamp.Behaviour.html#c:milli_seconds/0","title":"Riverside.IO.Timestamp.Behaviour.milli_seconds/0","type":"callback"},{"doc":"","ref":"Riverside.IO.Timestamp.Behaviour.html#c:seconds/0","title":"Riverside.IO.Timestamp.Behaviour.seconds/0","type":"callback"},{"doc":"","ref":"Riverside.IO.Timestamp.Real.html","title":"Riverside.IO.Timestamp.Real","type":"module"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html","title":"Riverside.IO.Timestamp.Sandbox","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.IO.Timestamp.Sandbox.html#child_spec/1","title":"Riverside.IO.Timestamp.Sandbox.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html#mode/1","title":"Riverside.IO.Timestamp.Sandbox.mode/1","type":"function"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html#set_milli_seconds/1","title":"Riverside.IO.Timestamp.Sandbox.set_milli_seconds/1","type":"function"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html#set_seconds/1","title":"Riverside.IO.Timestamp.Sandbox.set_seconds/1","type":"function"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html#start_link/1","title":"Riverside.IO.Timestamp.Sandbox.start_link/1","type":"function"},{"doc":"","ref":"Riverside.IO.Timestamp.Sandbox.html#t:mode/0","title":"Riverside.IO.Timestamp.Sandbox.mode/0","type":"type"},{"doc":"","ref":"Riverside.LocalDelivery.html","title":"Riverside.LocalDelivery","type":"module"},{"doc":"","ref":"Riverside.LocalDelivery.html#close/2","title":"Riverside.LocalDelivery.close/2","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#deliver/2","title":"Riverside.LocalDelivery.deliver/2","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#deliver_message/3","title":"Riverside.LocalDelivery.deliver_message/3","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#join_channel/1","title":"Riverside.LocalDelivery.join_channel/1","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#leave_channel/1","title":"Riverside.LocalDelivery.leave_channel/1","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#register/2","title":"Riverside.LocalDelivery.register/2","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.html#t:destination/0","title":"Riverside.LocalDelivery.destination/0","type":"type"},{"doc":"","ref":"Riverside.LocalDelivery.Topic.html","title":"Riverside.LocalDelivery.Topic","type":"module"},{"doc":"","ref":"Riverside.LocalDelivery.Topic.html#channel/1","title":"Riverside.LocalDelivery.Topic.channel/1","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.Topic.html#session/2","title":"Riverside.LocalDelivery.Topic.session/2","type":"function"},{"doc":"","ref":"Riverside.LocalDelivery.Topic.html#user/1","title":"Riverside.LocalDelivery.Topic.user/1","type":"function"},{"doc":"Represents a peer's address This data has following three field address port x_forwarded_for","ref":"Riverside.PeerAddress.html","title":"Riverside.PeerAddress","type":"module"},{"doc":"Pick a peer's address from a cowboy request.","ref":"Riverside.PeerAddress.html#gather/1","title":"Riverside.PeerAddress.gather/1","type":"function"},{"doc":"","ref":"Riverside.PeerAddress.html#t:t/0","title":"Riverside.PeerAddress.t/0","type":"type"},{"doc":"Default Router module","ref":"Riverside.Router.html","title":"Riverside.Router","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"Riverside.Router.html#call/2","title":"Riverside.Router.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"Riverside.Router.html#init/1","title":"Riverside.Router.init/1","type":"function"},{"doc":"","ref":"Riverside.Session.html","title":"Riverside.Session","type":"module"},{"doc":"","ref":"Riverside.Session.html#countup_messages/2","title":"Riverside.Session.countup_messages/2","type":"function"},{"doc":"","ref":"Riverside.Session.html#forget_to_trap_exit/2","title":"Riverside.Session.forget_to_trap_exit/2","type":"function"},{"doc":"","ref":"Riverside.Session.html#new/3","title":"Riverside.Session.new/3","type":"function"},{"doc":"","ref":"Riverside.Session.html#peer_address/1","title":"Riverside.Session.peer_address/1","type":"function"},{"doc":"","ref":"Riverside.Session.html#should_delegate_exit?/2","title":"Riverside.Session.should_delegate_exit?/2","type":"function"},{"doc":"","ref":"Riverside.Session.html#trap_exit/2","title":"Riverside.Session.trap_exit/2","type":"function"},{"doc":"","ref":"Riverside.Session.html#t:session_id/0","title":"Riverside.Session.session_id/0","type":"type"},{"doc":"","ref":"Riverside.Session.html#t:t/0","title":"Riverside.Session.t/0","type":"type"},{"doc":"","ref":"Riverside.Session.html#t:user_id/0","title":"Riverside.Session.user_id/0","type":"type"},{"doc":"","ref":"Riverside.Session.TransmissionLimitter.html","title":"Riverside.Session.TransmissionLimitter","type":"module"},{"doc":"","ref":"Riverside.Session.TransmissionLimitter.html#countup/3","title":"Riverside.Session.TransmissionLimitter.countup/3","type":"function"},{"doc":"","ref":"Riverside.Session.TransmissionLimitter.html#new/0","title":"Riverside.Session.TransmissionLimitter.new/0","type":"function"},{"doc":"","ref":"Riverside.Session.TransmissionLimitter.html#t:t/0","title":"Riverside.Session.TransmissionLimitter.t/0","type":"type"},{"doc":"","ref":"Riverside.Stats.html","title":"Riverside.Stats","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.Stats.html#child_spec/1","title":"Riverside.Stats.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.Stats.html#countdown_connections/0","title":"Riverside.Stats.countdown_connections/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#countup_connections/0","title":"Riverside.Stats.countup_connections/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#countup_incoming_messages/0","title":"Riverside.Stats.countup_incoming_messages/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#countup_outgoing_messages/0","title":"Riverside.Stats.countup_outgoing_messages/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#current_state/0","title":"Riverside.Stats.current_state/0","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Riverside.Stats.html#init/1","title":"Riverside.Stats.init/1","type":"function"},{"doc":"","ref":"Riverside.Stats.html#number_of_current_connections/0","title":"Riverside.Stats.number_of_current_connections/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#number_of_messages/0","title":"Riverside.Stats.number_of_messages/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#number_of_total_connections/0","title":"Riverside.Stats.number_of_total_connections/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#start_link/0","title":"Riverside.Stats.start_link/0","type":"function"},{"doc":"","ref":"Riverside.Stats.html#start_link/1","title":"Riverside.Stats.start_link/1","type":"function"},{"doc":"","ref":"Riverside.Supervisor.html","title":"Riverside.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.Supervisor.html#child_spec/1","title":"Riverside.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Riverside.Supervisor.html#init/1","title":"Riverside.Supervisor.init/1","type":"function"},{"doc":"","ref":"Riverside.Supervisor.html#start_link/1","title":"Riverside.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html","title":"Riverside.Test.TestClient","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Riverside.Test.TestClient.html#child_spec/1","title":"Riverside.Test.TestClient.child_spec/1","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#connect/4","title":"Riverside.Test.TestClient.connect/4","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#new/2","title":"Riverside.Test.TestClient.new/2","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#send_message/2","title":"Riverside.Test.TestClient.send_message/2","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#start_link/1","title":"Riverside.Test.TestClient.start_link/1","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#stop/1","title":"Riverside.Test.TestClient.stop/1","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#test_message/2","title":"Riverside.Test.TestClient.test_message/2","type":"function"},{"doc":"","ref":"Riverside.Test.TestClient.html#wait_to_test/3","title":"Riverside.Test.TestClient.wait_to_test/3","type":"function"},{"doc":"","ref":"Riverside.Test.TestServer.html","title":"Riverside.Test.TestServer","type":"module"},{"doc":"","ref":"Riverside.Test.TestServer.html#start/3","title":"Riverside.Test.TestServer.start/3","type":"function"},{"doc":"","ref":"Riverside.Test.TestServer.html#stop/1","title":"Riverside.Test.TestServer.stop/1","type":"function"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html","title":"Riverside.Util.CowboyUtil","type":"module"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html#headers/1","title":"Riverside.Util.CowboyUtil.headers/1","type":"function"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html#peer/1","title":"Riverside.Util.CowboyUtil.peer/1","type":"function"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html#queries/1","title":"Riverside.Util.CowboyUtil.queries/1","type":"function"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html#response/3","title":"Riverside.Util.CowboyUtil.response/3","type":"function"},{"doc":"","ref":"Riverside.Util.CowboyUtil.html#x_forwarded_for/1","title":"Riverside.Util.CowboyUtil.x_forwarded_for/1","type":"function"}]